const
	script_name='FilmAffinity';
	language='Spanish';
	version=11;
	author='Vlad';
	MinProgramBuild=4500;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary: string;
	movie_code, movie_site_url, title_code, imdb_code, awards: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	imdb_rating, rating: double;
	front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	title, original_title, small_cover, description, year, s3: string;
begin
	s:='';
	titles_count:=0;
	i:=pos('squeda de', all);
	j:=MyPos('- FilmAffinity</title>', all, i+1);
	//if the search is forwarded to the details page
	if (i=0) or (j=0) then begin
		i:=pos('movie_id=', all);
		j:=MyPos('"', all, i+9);
		title_code:=copy(all, i+9, j-i-9);
		if title_code<>'' then begin
			titles_count:=1;
			SetSearchResult(title, title_code);
		end;
	end;

	i:=pos('Resultados', all);
	if i>0 then begin
		j:=MyPos('Si no encuentras', all, i+1);
		if j>0 then
			s:=copy(all, i, j-i);
	end;

	if (s='') or (pos('<b>0 resultados', all)>0) then
	//movie not found

	else begin         
	  i := pos('a href="/es/film',s);
	  s := copy(s,i,length(s));
	  i := 1;
	  j := MyPos('</td></tr></table></div>', s, 1);
	  while j>0 do begin
			titles_count:=titles_count+1;
			s2:=copy(s, i, j-i);
					
			title_code:=ParseString(s2, '<a href="/es/film(\d+).html', 1);
			title:=ParseString(s2, '<a href="/es/film\d+.html">(.*?)</a></b>', 1);
			title:=DecodeHTML(title);
			title:=ClearExtraSpaces(title);
			//original title - none
			original_title := '';
			//small cover
			small_cover := ParseString(s2, '<img src="http:\/\/pics\.filmaffinity\.com\/(.*?)" ', 1);
			if small_cover <> '' then
				small_cover := 'http://pics.filmaffinity.com/' + small_cover;
				
			//year
			year := '';
			k := Pos('</a></b>', s2);
			if k>0 then begin
				l := MyPos('<img', s2, i+1);
				s3 := copy(s2, k, l-k);
				year := ParseString(s3, '\((\d+)\)', 1);
			end;
			
			//description
			description := ParseString(s2, '<tr><td><span style="font-size: 10px; color:#666666"><b>(.*?)</b></span></td></tr>', 1);
			description := RemoveTags(DecodeHTML(description));
			
			SetSearchResult2(title, title_code, year, original_title, description, small_cover);
		    delete(s, 1, j+4);
			i:=MyPos('a href="/es/film', s, 1);
			j:=MyPos('</td></tr></table></div>', s, i+1);
	  end;
	end;
	result:=titles_count;

end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	url:=format('http://www.filmaffinity.com/es/search.php?stext=%s&stype=title', [MovieName]);
	url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
		result:=format('http://www.filmaffinity.com/es/film%s.html', [code])
end;

//returned link to front cover
function GetAmazonImages: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j: integer;
begin
	s:=original_title;
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [original_title]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	amazon_url:='';
	i:=pos('<Item>', all);
	while (i>0) and (amazon_url='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			s3:=DecodeHTML(s3);
			if s3<>'' then 
			begin
				//if title=s3 then begin //!!!
				if pos(UpperCase(original_title), UpperCase(s3))=1 then 
				begin
					amazon_url:=ParseString(s2, '<LargeImage><URL>(.*?)</URL>', 1);
				end;
			end;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	if amazon_url<>'' then begin
		SetImageName('', amazon_url, '', 1);
		res:=amazon_url;
	end;
	result:=res;
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes "
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank characters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, plot_outline: string;
	i, j, k: integer;
begin
	result:='';
	BasicURL:=url;
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;

	movie_code:=ParseString(url, 'http://www.filmaffinity.com/es/film(\d+).html', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);

	//movie title
	title:=ParseString(all, '<title>(.*?) \(', 1);
	title:=RemoveTags(title);
	title:=DecodeHTML(title);
	title:=ClearExtraSpaces(title);
	title := ClearExtraQuotes(title);
	title := MovePrefixLeft(title);
	if title='' then exit;

	//original title
	i:=pos('TULO ORIGINAL', all);
	if i>0 then begin
		i:=i+13;
		j:=MyPos('</strong></td>', all, i+1);
		original_title:=copy(all, i, j-i);
		original_title:=RemoveTags(original_title);
		original_title:=DecodeHTML(original_title);
		original_title:=ClearExtraSpaces(original_title);
	end;
	
	//year
	year := ParseString(all, '<title>.*?\((\d+)\)', 1);

	//duration, minutes
	duration:=0;
	i := Pos('<th>DURACI&Oacute;N</th>', all);
	if i>0 then begin
		i := MyPos('</div>', all, i+1);
		j := MyPos('</td>', all, i+1);
		s := copy(all, i, j-i);
		s := RemoveTags(s);
		s := ClearExtraBlankCharacters(s);
		s2:=ParseString(s, '^(\d+) min.', 1);
		if s2<>'' then
			try
			duration:=StrToInt(s2);
			except
			end;
	end;

	//directors
	i:=pos('<th>DIRECTOR</th>', all);
	if i>0 then begin
		j:=MyPos('</tr>', all, i+1);
		k:=j;
		s2:=copy(all, i+17, j-i-17);
		i:=pos('<a href=', s2);
		i:=MyPos('">', s2, i+1);
		j:=MyPos('</a>', s2, i+1);
		while i>0 do begin
			s3:=copy(s2, i+2, j-i-2);
			name:=RemoveTags(s3);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 1, '');
			delete(s2, 1, i+2);
			i:=pos('">', s2);
			j:=MyPos('</a>', s2, i+1);
		end;
	end;
	
	//writers
	name:='';
	i:=Pos('<th>GUI&Oacute;N</th>', all);
	j:=MyPos('</td>', all, i+1);
	s2:=copy(all, i+21, j-i-21);
	if s2<>'' then begin
		i:=pos(',', s2);
		k:=pos('(', s2);
		if k=0 then
			k:=length(s2);
		while (i>0) and (k>i) do begin
			name:=copy(s2, 1, i-1);
			name:=RemoveTags(name);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 2, '');
			delete(s2, 1, i);
			k:=k-i;
			i:=pos(',', s2);
		end;
		i:=pos('&amp', s2);
		if (i>0) and (k>i) then begin
			name:=copy(s2, 1, i-1);
			name:=RemoveTags(name);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 2, '');
			delete(s2, 1, i+4);
		end;
		i:=pos('(', s2);
		if i>0 then begin
			name:=copy(s2, 1, i-1);
			name:=RemoveTags(name);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 2, '');
			delete(s2, 1, i);
		end;
		if (pos(')', s2)<=0) then begin
			name:=s2;
			name:=RemoveTags(name);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 2, '');
		end;
	end;
	
	//actors
	i:=pos('<th>REPARTO</th>', all);
	if i>0 then begin
		j:=MyPos('</tr>', all, i+1);
		s2:=copy(all, i+16, j-i-16);
		i:=pos('<a href=', s2);
		j:=MyPos('</a>', s2, i+1);
		while j>0 do begin
			s3:=copy(s2, 1, j+5);
			name:=ParseString(s3, '<a href=.*?">(.*?)</a>', 1);
			name:=RemoveTags(name);
			name:=DecodeHTML(name);
			name:=ClearExtraSpaces(name);
			if name<>'' then
				setPersonName(name, '', 3, '');
			delete(s2, 1, j+5);
			j:=pos('</a>', s2);
		end;
	end;

	//image
	// small image
	i:=pos('http://www.filmaffinity.com/imgs/movies/full', all);
	s:=copy(all, i, 58);
	// big image
	i:=pos('<a class="lightbox" href="', all);
	if (i>0) then begin
	   j:=MyPos('" title="', all, i);
	   s:=copy(all, i+26,j-i-26);
	end;
	front_cover_url:=s;

	//description
	k:=0;
	i:=pos('<th>SINOPSIS</th>', all);
	i:=i+17;
	if (i<=17) then begin
		i:=pos('PRODUCTORA', all);
		i:=MyPos('TICA', all, i+1);
		i:=MyPos(' / ', all, i+1);
		k:=MyPos(' / ', all, i+3);
	end;
	if k>i then i:=k;
	i:=i+3;
	j:=MyPos('</td>', all, i+1);
	description:=copy(all, i, j-i);
	description:=DecodeHTML(description);
	description:= ReplaceStr(description, '<br />', '', -1);
	description:= RemoveTags(description);
	description:=ClearExtraSpaces(description);

	//music
	s3:='';
	i:=pos('<th>M&Uacute;SICA</th>', all);
	j:=MyPos('</td>', all, i+1);
	s2:=copy(all, i+22, j-i-22);
	i:=pos('(', s2);
	if i>0 then begin
		j:=MyPos(')', s2, i+1);
		s3:=copy(s2, i+1, j-i-1);
		delete(s2, i, j-i+1);
	end;
	if s3<>'' then
		k:=2
	else
		k:=1;
	while k>0 do begin
		i:=pos(',', s2);
		if i=0 then
			i:=pos('/ ', s2);
		while i>0 do begin
			name:=copy(s2, 1, i-1);
			name:=RemoveTags(DecodeHTML(name));
			if name<>'' then
				SetPersonName(name, '', 4, '');
			delete(s2, 1, i+1);
			i:=pos(',', s2);
			if i=0 then
				i:=pos('/ ', s2);
		end;
		name:=RemoveTags(DecodeHTML(s2));
		if name<>'' then
			SetPersonName(name, '', 4, '');
		i:=pos('Tema: ', s3);
		if i>0 then
			delete(s3, i, i+5);
		s2:=s3;
		k:=k-1;
	end;
	
	//studios
	i:=pos('<th>PRODUCTORA</th>', all);
	j:=MyPos('</td>', all, i+1);
	s2:=copy(all, i+19, j-i-19);
	i:=pos(',', s2);
	if i=0 then
		i:=pos('/ ', s2);
	while i>0 do begin
		name:=copy(s2, 1, i-1);
		name:=RemoveTags(DecodeHTML(name));
		if name<>'' then
			SetStudio(name);
		delete(s2, 1, i+1);
		i:=pos(',', s2);
		if i=0 then
			i:=pos('/ ', s2);
	end;
	name:=RemoveTags(DecodeHTML(s2));
	if name<>'' then
		SetStudio(name);	
  
	//premios
	i:=pos('<th>PREMIOS</th>', all);
	if i>0 then begin
		j := MyPos('</tr>', all, i+1);
		s2 := copy(all, i+16, j-i-16);
		s2 := RemoveTags(s2);
		awards := DecodeHTML(s2);
	end;
	
	//genres
	i:=pos('<th>G&Eacute;NERO</th>', all);
	if i>0 then begin
		j := MyPos('</td>', all, i+18);
		s2 := copy(all, i+22, j-i-22);
		i := Pos('<a href', s2);
		while i>0 do begin
			j := MyPos('</a>', s2, i+1);
			s3 := copy(s2, i, j-i);
			name := RemoveTags(s3);
			name := DecodeHTML(name);
			if name<>'' then
				SetGenre(name);
			delete(s2, 1, j);
			i := Pos('<a href', s2);
		end;
	end;

	//country
	name:=ParseString(all, '<img src="/imgs/countries/.*?" title="(.*?)" border="0"', 1);
	setCountry(name);
	
	// Valoracion
	i:= pos('color:#990000; font-size:22px; font-weight: bold;',all);
  if i>0 then begin
    i:= MyPos('">', all, i+1);
    j:= MyPos('</div>',all,i);
    s:= copy(all, i+2,j-i-2);
    try
      rating:=StrToFloat(s);
		except
		end;
  end;
	
  // Trailers
(*  i:= pos('<a href="/es/evideos.php?movie_id=',all);
  if i>0 then begin
     j:= MyPos('">Trailers', all, i);
     s:= copy(all, i+9, j-i-9);
     s:= 'http://www.filmaffinity.com' + s;
     all:=DownloadURL(s);
     i:= pos('<div id="divec1" style="padding: 4px;">', all);
     if i>0 then begin
        i:= MyPos('value="http://', all, i);
        j:= MyPos('"></param>', all, i);
        s:= copy(all, i+14, j-i-14);
        description:= description + '<br><a href="link:' + s + '">Ver trailer online</a>';
     end;
  end; 
*)
end;

//returned images links
procedure GetImages;
begin
	if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.filmaffinity.com/es/film'+code+'.html';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	result:='';
end;

begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.